
'[!] As of 2023 04/26, all noted timestamps are in YYYY MM/DD format. -- Keal

#Lang "QB"
Option GoSub
DEFLNG A-Z

Type XYM_Type
	As Long x, y, m
End Type

ReDim Shared As XYM_Type Array_XYM ( 0 To 255 )

Type CSV_Type
	As String Filename
	As Long Filemode
	As String LineBuffer
	As Long LineIndex
	As String ReserveBuffer, QueueBuffer
	As String LinePrefix, LineSuffix
	As Long Index, Count
End Type

Dim Shared As CSV_Type CSV ( 0 To 255 )

Type Pal_Type
	As Long VGA
	As Long R, G, B
	As Long Index, Count
End Type

Type D_Type
	As Long X, Y
End Type

ReDim Shared As CSV_Type CSV_Stream ( 255 )

Const CSV_MG = 1, CSV_MGB = 2, CSV_MGC = 3
Const CSV_GR4 = 4, CSV_GR5 = 5
Const CSV_GM = 6, CSV_Pal = 7

'#Include Once "..\Alisha's DevKit ( v122-87 )\FBImage .bi"
'#Include Once "..\Alisha's DevKit ( v122-87 )\libpng .bas"

Const LEFTBUTTON  = 1
Const MIDDLEBUTTON = 4  ' UNUSED IN THIS DEMO
Const RIGHTBUTTON = 2  ' UNUSED IN THIS DEMO
Const SHOWMOUSE  = 1
Const HIDEMOUSE  = 0

Dim Shared As Long px, py, PB

ReDim Shared array_x ( 10 ), array_y ( 10 ), array_m ( 10 )
ReDim Shared array_a$( 10 )

ReDim Shared As D_Type Array_Rose ( 10 ) : REM '''directions

ReDim Shared array_rd$ ( 10 ), array_bm$( 10 ), array_gm$( 10 ), array_ck$( 10 )

COMMON SHARED sz
'[!]bugfix 1999 12/01 - the line below has +11 instead of +8 to fix clipboard allocation
DIM SHARED array_scn ( 24 * 24 + 11 ): REM '''clipboard
REM'DIM SHARED vm$( gz ): REM '''graphics ID

DIM SHARED array_gr (-3 TO 3, -3 TO 3 ): REM '''terrein view map
DIM SHARED array_cr (-3 TO 3, -3 TO 3 ): REM '''object view map
DIM SHARED array_cs (-3 TO 3, -3 TO 3 ): REM '''object view map
DIM SHARED array_lc (-3 TO 3, -3 TO 3 ): REM '''modified creation
DIM SHARED array_clr ( 0 TO 15, 1 TO 3 ): REM '''16 color RGB, scrnmode 9
DIM SHARED array_pal ( 0 TO 255, 1 TO 3 ): REM '''256 palette RGB, scrnmode 13

om$ = "pzlm_w05 .mom": DIM array_obj$( 0 TO 255, 1 TO 4 ): DIM array_obj ( 0 TO 255 ): DIM objs ( 0 TO 255 ): DIM array_obj_m ( 0 TO 255 )

DECLARE SUB graphicput ( grpt$, x, y, m$)
0 :
REM'OverWorld - 1996 04/03 -- Keal
REM'Updated: 1997 31/08 -- Keal
REM'Updated: 1998 17/12 -- Keal
REM'--
REM'email: trkeal@gmail.com
REM'--
REM'update 1999 12/01 -- Keal ( Timestamp method Obsolete, 2023 04/26 -- Keal )
REM'bugfixes are represented as 8 digit date code as month## day## year####
REM'bugfixes can now be searched for by looking for '[!]'
REM'same goes for updates
REM'header format:
REM'action mmddyyyy - programmer {company}
REM'( info about action )
REM'companies:
REM'AG47 = Aquarius Games
REM'--
REM'bugfix 1999 12/01 -- Keal
REM'allows map to load and save new position correctly
REM'corrected clipboard allocation
REM'allows arrow keys to move and change direction
REM'--
REM'update 1999 12/01 -- Keal
REM'program has rem'd lines to display coordinates
REM'program has rem'd lines to display key code
REM'--
REM'update 1999 13/01 -- Keal
REM'altered VGA_ED02 .BAS so that it can select any path
REM'added new animated water graphic
REM'added palette rotation animation to colors 239 - 242
REM'shallow and deep water now appear the same
REM'can now swim through shallow water
REM'added palette rotation to VGA_ED02 .BAS
REM'made waterfall graphic animated
REM'added swimways to lower regions of map
REM'added snowy mountains and waterfall to lower regions of map
REM'added swarm of life to lower regions of map
REM'--
REM'update 1999 14/01 -- Keal
REM'increased refresh rate
REM'stopped all creature flickering at price of less animation
REM'made it so creatures cannot swap places with a still object
REM'allowed animation of creatures, more flickering though
REM'stopped still creature flickering at price of less animation
REM'--
REM'update 1999 17/01 -- Keal
REM'added array_obj_m ( z )
REM'determines whether still objects are beneath/behind or above/before
REM'animate creatures as well as whether each SO type may be boarded
REM'allowed objs ( z ) to control speed of AC
REM'--
REM'bugfix 1999 17/01 -- Keal
REM'made it so AC's no longer move SO's
REM'set array_obj_m ( 0 ) to 1 so that nothing is not blocking
REM'fixed spotput and spotupdt so that they account for array_obj_m ( z )
REM'--

'---

ReDim As Pal_Type Array_Pal ( 0 To 255 )

CSV ( CSV_Pal ) .Filename = "16 Color.csv"
CSV ( CSV_Pal ) .Filemode = FreeFile

Open CSV ( CSV_Pal ) .Filename For Input As # CSV ( CSV_Pal ) .Filemode

Do While Eof ( CSV ( CSV_Pal ) .Filemode ) = 0
	
	Input # CSV ( CSV_Pal ) .Filemode CSV ( CSV_Pal ) .Index
	
	Select Case Eof ( CSV ( CSV_Pal ) .Filemode )
	Case 0
		Input # CSV ( CSV_Pal ) .Filemode Array_Pal ( CSV ( CSV_Pal ) .Index ) .R, Array_Pal ( CSV ( CSV_Pal ) .Index ) .G, Array_Pal ( CSV ( CSV_Pal ) .Index ) .B
	End Select	
Loop

Close # CSV ( CSV_Pal ) .Filemode

For CSV ( CSV_Pal ) .Index = LBound ( CSV ( CSV_Pal ), 1 ) To UBound ( CSV ( CSV_Pal ), 1 ) Step 1
	Array_Pal ( CSV ( CSV_Pal ) .Index ) .VGA = __RGBA ( Array_Pal ( CSV ( CSV_Pal ) .Index ) .R, Array_Pal ( CSV ( CSV_Pal ) .Index ) .G, Array_Pal ( CSV ( CSV_Pal ) .Index ) .B, 255 )
	Array_Pal ( CSV ( CSV_Pal ) .Index ) .VGA = __RGBA ( Array_Pal ( CSV ( CSV_Pal ) .Index ) .R, Array_Pal ( CSV ( CSV_Pal ) .Index ) .G, Array_Pal ( CSV ( CSV_Pal ) .Index ) .B, 255 )
Next CSV ( CSV_Pal ) .Index

'---

ReDim As Rose_Type Array_Rose ( 0 To 255 )

CSV ( CSV_Rose ) .Filename = "Rose.csv"
CSV ( CSV_Rose ) .Filemode = FreeFile

Open CSV ( CSV_Rose ) .Filename For Input As # CSV ( CSV_Rose ) .Filemode
CSV ( CSV_Rose ) .Index = 0

Do While Eof ( CSV ( CSV_Rose ) .Filemode ) = 0
	Input # CSV ( CSV_Rose ) .Filemode CSV ( CSV_Rose ) .Index
	Select Case Eof ( CSV ( CSV_Rose ) .Filemode )
	Case 0
		Input # CSV ( CSV_Rose ) .Filemode Array_Rose ( CSV ( CSV_Rose ) .Index ) .X, Array_Rose ( CSV ( CSV_Rose ) .Index ) .Y
	End Select
Loop

Close # CSV ( CSV_Rose ) .Filemode

/'
Array_Rose ( 0 ) .X = 0: Array_Rose ( 0 ) .Y = 0
Array_Rose ( 1 ) .X = 0: Array_Rose ( 1 ) .Y = -1
Array_Rose ( 2 ) .X = 1: Array_Rose ( 2 ) .Y = 0
Array_Rose ( 3 ) .X = 0: Array_Rose ( 3 ) .Y = 1
Array_Rose ( 4 ) .X = -1: Array_Rose ( 4 ) .Y = 0
'/

Dim Shared As Long SCRN
SCRN = 13
SCREEN SCRN
COLOR 15
CLS

__SetMouse ( 1, 1, SHOWMOUSE )

'-----

CSV ( CSV_Pal ) .Filename = "Pal v05.csv"
CSV ( CSV_Pal ) .Filemode = FreeFile

Open CSV ( CSV_Pal ) .Filename For Input As # CSV ( CSV_Pal ) .Filemode

Do While Eof ( CSV ( CSV_Pal ) .Filemode ) = 0
	
	Input # CSV ( CSV_Pal ) .Filemode CSV ( CSV_Pal ) .Index
	
	Select Case Eof ( CSV ( CSV_Pal ) .Filemode )
	Case 0
		Input # CSV ( CSV_Pal ) .Filemode Array_Pal ( CSV ( CSV_Pal ) .Index ) .R, Array_Pal ( CSV ( CSV_Pal ) .Index ) .G, Array_Pal ( CSV ( CSV_Pal ) .Index ) .B
	End Select	
Loop

Close # CSV ( CSV_Pal ) .Filemode

For CSV ( CSV_Pal ) .Index = LBound ( CSV ( CSV_Pal ), 1 ) To UBound ( CSV ( CSV_Pal ), 1 ) Step 1
	Array_Pal ( CSV ( CSV_Pal ) .Index ) .VGA = __RGBA ( Array_Pal ( CSV ( CSV_Pal ) .Index ) .R, Array_Pal ( CSV ( CSV_Pal ) .Index ) .G, Array_Pal ( CSV ( CSV_Pal ) .Index ) .B, 255 )
	Array_Pal ( CSV ( CSV_Pal ) .Index ) .VGA = __RGBA ( Array_Pal ( CSV ( CSV_Pal ) .Index ) .R, Array_Pal ( CSV ( CSV_Pal ) .Index ) .G, Array_Pal ( CSV ( CSV_Pal ) .Index ) .B, 255 )
Next CSV ( CSV_Pal ) .Index

'-----

FOR t2 As Long = 1 TO 16
	t = t2 + 174 + 16 * 3
	Array_Pal ( t ) .R = 0
	Array_Pal ( t ) .G = INT ( 63 * .5 * t2 / 16 + 15 )
	Array_Pal ( t ) .B = INT ( 63 * t2 / 16 )
	PALETTE t, __RGBA ( Array_Pal ( t ) .R, Array_Pal ( t ) .G, Array_Pal ( t ) .B, 255 )
NEXT t2

t = t2

RANDOMIZE TIMER
RESTORE
WIDTH 40, 25

array_clr ( 0, 1 ) = 0: array_clr ( 0, 2 ) = 0: array_clr ( 0, 3 ) = 0
array_clr ( 1, 1 ) = 2: array_clr ( 1, 2 ) = 0: array_clr ( 1, 3 ) = 0
array_clr ( 2, 1 ) = 0: array_clr ( 2, 2 ) = 2: array_clr ( 2, 3 ) = 0
array_clr ( 3, 1 ) = 2: array_clr ( 3, 2 ) = 2: array_clr ( 3, 3 ) = 0
array_clr ( 4, 1 ) = 0: array_clr ( 4, 2 ) = 0: array_clr ( 4, 3 ) = 2
array_clr ( 5, 1 ) = 2: array_clr ( 5, 2 ) = 0: array_clr ( 5, 3 ) = 2
array_clr ( 6, 1 ) = 0: array_clr ( 6, 2 ) = 2: array_clr ( 6, 3 ) = 2
array_clr ( 7, 1 ) = 2: array_clr ( 7, 2 ) = 2: array_clr ( 7, 3 ) = 2
array_clr ( 8, 1 ) = 1: array_clr ( 8, 2 ) = 1: array_clr ( 8, 3 ) = 1
array_clr ( 9, 1 ) = 3: array_clr ( 9, 2 ) = 0: array_clr ( 9, 3 ) = 0
array_clr ( 10, 1 ) = 0: array_clr ( 10, 2 ) = 3: array_clr ( 10, 3 ) = 0
array_clr ( 11, 1 ) = 3: array_clr ( 11, 2 ) = 3: array_clr ( 11, 3 ) = 0
array_clr ( 12, 1 ) = 0: array_clr ( 12, 2 ) = 0: array_clr ( 12, 3 ) = 3
array_clr ( 13, 1 ) = 3: array_clr ( 13, 2 ) = 0: array_clr ( 13, 3 ) = 3
array_clr ( 14, 1 ) = 0: array_clr ( 14, 2 ) = 3: array_clr ( 14, 3 ) = 3
array_clr ( 15, 1 ) = 3: array_clr ( 15, 2 ) = 3: array_clr ( 15, 3 ) = 3

'16 color RGB, scrnmode 9
REM'FOR clror = 0 TO 15
REM' PALETTE clror, array_clr ( clror, 1 ) + array_clr ( clror, 2 ) * 4 + array_clr ( clror, 3 ) * 4 ^ 2
REM'NEXT clror

timm = 0
timh = 0
timd = 0
pal = 1

100 BR = TIMER: bt = .2: gc = 1: sb = TIMER: sa = .1: GE = 1
105 vx2 = 1: vy2 = 1: d1 = 1
106 Array_XYM ( 1 ) .x = 0: Array_XYM ( 1 ) .y = -1: Array_XYM ( 1 ) . m = 3
107 Array_XYM ( 2 ) .x = 1: Array_XYM ( 2 ) .y = 0: Array_XYM ( 2 ) . m = 0
108 Array_XYM ( 3 ) .x = 0: Array_XYM ( 3 ) .y = 1: Array_XYM ( 3 ) . m = 1
109 Array_XYM ( 4 ) .x = -1: Array_XYM ( 4 ) .y = 0: Array_XYM ( 4 ) . m = 2
115 array_a$( 0 ) = CHR$( 4 ): array_a$( 1 ) = CHR$( 24 ): array_a$( 2 ) = CHR$( 26 ): array_a$( 3 ) = CHR$( 25 ): array_a$( 4 ) = CHR$( 27 )
120 's=1:o=4:i=1
125 vx1 = 9: vy1 = 15: d1 = 1: vx2 = vx1: vy2 = vy1: d2 = d1: ''''chtr mem
128 nm$ = "Pndx"

130 :
'''''Area mem load
''''LINE ( 0, 0 )-( 319, 199 ), 0, BF

/'Close # CSV_Stream ( CSV_SAV ) .Filemode :'/ CSV_Stream ( CSV_SAV ) .Filemode = FreeFile ( )
OPEN nm$ + "_001.sav" FOR INPUT AS # CSV_Stream ( CSV_SAV ) .Filemode
INPUT # CSV_Stream ( CSV_SAV ) .Filemode, p1$, vx2, vy2, d1, vx2, vy2, nm$, c1$, c2$, c3$, s, o, i, p
CLOSE # CSV_Stream ( CSV_SAV ) .Filemode

Close # CSV_Stream ( CSV_TXT ) .Filemode : CSV_Stream ( CSV_TXT ) .Filemode = FreeFile ( )
OPEN p1$ + ".txt" FOR INPUT AS # CSV_Stream ( CSV_TXT ) .Filemode
INPUT # CSV_Stream ( CSV_TXT ) .Filemode, P2$, p3$, xx, yy, array_ck$( 1 ), array_ck$( 2 ), array_ck$( 3 ), array_ck$( 4 ), rd$, bm$
rd$ = " " + rd$ + " "

/'Close # CSV_Stream ( CSV_BM ) .Filemode :'/ CSV_Stream ( CSV_BM ) .Filemode = FreeFile ( )
'OPEN bm$ FOR INPUT AS CSV_Stream ( CSV_BM ) .Filemode

140 :
sz = 24: gz = 256: '''map mem
bm$ = p1$ + " .bgm": '''music
'''terrein graphics ID
gm$ = "pzlm_w05 .mem": DIM vm$( gz ): DIM varray_m ( gz ): tx = 1: ty = 1
'''object graphics ID/size/speed/mask
'id is four frames of animation
'size is 4 to 24, multiple of 2
'speed is 0 to whatever, 0 means no move, higher number=more often move
'mask is 0 for under AC ( AC's not move onto ),1 for under AC,2 for above AC

'[!]bugfix 1999 17/01
array_obj_m ( 0 ) = 1

'SHELL "copy pzlm_w06 .map pzlm_gr1.tmp"
'SHELL "copy pzlm_w06 .map pzlm_gr2.tmp"
'SHELL "copy pzlm_w06 .map pzlm_gr3.tmp"

mg$ = "pzlm_gr1.tmp": REM'DIM array_gr ( xx + 1, yy + 1 ): '''terrein map
mgb$ = "pzlm_gr2.tmp": '''object map
mgc$ = "pzlm_gr3.tmp": '''low object map
sv$ = p1$ + ".sav"
bt$ = p1$ + " .btl"
c1$ = "001"
c2$ = "002"
c3$ = "003"

''''LINE ( 0, 0 )-( 319, 199 ), 0, BF
/'Close # CSV_Stream ( CSV_TG ) .Filemode : CSV_Stream ( CSV_TG ) .Filemode = FreeFile ( )'/
280 :
'''''terrein Graphics Load
t = 8: tt = 8

'Dim As Long CSV_GM = 5

Close # CSV_Stream ( CSV_GM ) .Filemode : CSV_Stream ( CSV_GM ) .Filemode = FreeFile ( )
OPEN gm$ FOR INPUT AS # CSV_Stream ( CSV_GM ) .Filemode

FOR z = 1 TO gz
 INPUT # CSV_Stream ( CSV_GM ) .Filemode, vm$( z )
 FOR zz = 1 TO 4
  INPUT # CSV_Stream ( CSV_GM ) .Filemode, r
  IF r = zz THEN array_ck$( zz ) = array_ck$( zz ) + STR$( z )
 NEXT zz
 INPUT # CSV_Stream ( CSV_GM ) .Filemode, varray_m ( z )
NEXT z

FOR zz = 1 TO 4
 array_ck$( zz ) = array_ck$( zz ) + " "
NEXT zz

Close # CSV_Stream ( CSV_OM ) .Filemode : CSV_Stream ( CSV_OM ) .Filemode = FreeFile ( )

'''''object Graphics Load
OPEN om$ FOR INPUT AS # CSV_Stream ( CSV_OM ) .Filemode
FOR z = 1 TO 255
 INPUT # CSV_Stream ( CSV_OM ) .Filemode, array_obj$( z, 1 ), array_obj$( z, 2 ), array_obj$( z, 3 ), array_obj$( z, 4 ), array_obj ( z ), objs ( z ), array_obj_m ( z )
NEXT z
Close # CSV_Stream ( CSV_OM ) .Filemode /': CSV_Stream ( 1 ) = FreeFile ( )'/
'gosub 50000

300 :
'''''Map Load & View Screen
LINE ( 0, 0 )-( 319, 199 ), 0, BF
'[!]bugfix 1999 12/01'vx2 = 9
'[!]bugfix 1999 12/01'vy2 = 45
310 :
Close # CSV_Stream ( CSV_MG ) .Filemode : CSV_Stream ( CSV_MG ) .Filemode = FreeFile ( )
OPEN mg$ FOR BINARY AS # CSV_Stream ( CSV_MG ) .Filemode
Close # CSV_Stream ( CSV_MGB ) .Filemode : CSV_Stream ( CSV_MGB ) .Filemode = FreeFile ( )
OPEN mgb$ FOR BINARY AS # CSV_Stream ( CSV_MGB ) .Filemode
Close # CSV_Stream ( CSV_MGC ) .Filemode : CSV_Stream ( CSV_MGC ) .Filemode = FreeFile ( )
OPEN mgc$ FOR BINARY AS # CSV_Stream ( CSV_MGC ) .Filemode
Close # CSV_Stream ( CSV_GR4 ) .Filemode : CSV_Stream ( CSV_GR4 ) .Filemode = FreeFile ( )
OPEN "pzlm_gr4.tmp" FOR BINARY AS # CSV_Stream ( CSV_GR4 ) .Filemode
Close # CSV_Stream ( CSV_GR5 ) .Filemode : CSV_Stream ( CSV_GR5 ) .Filemode = FreeFile ( )
OPEN "pzlm_gr5.tmp" FOR BINARY AS # CSV_Stream ( CSV_GR5 ) .Filemode
xx$ = SPACE$( 2 )
yy$ = SPACE$( 2 )
GET # CSV_Stream ( CSV_MG ) .Filemode, 1, xx$
GET # CSV_Stream ( CSV_MG ) .Filemode, 3, yy$
wx = ASC ( MID$( xx$, 1, 1 )) * 256 + ASC ( MID$( xx$, 2, 1 ))
wy = ASC ( MID$( yy$, 1, 1 )) * 256 + ASC ( MID$( yy$, 2, 1 ))
'[!]bugfix 1999 12/01'vx2 = INT ( wx / 2 )
'[!]bugfix 1999 12/01'vy2 = INT ( wy / 2 )
IF vx2 - 3 < 1 THEN vx2 = 4
IF vy2 - 3 < 1 THEN vy2 = 4
IF vx2 + 3 > wx THEN vx2 = wx - 4
IF vy2 + 3 > wy THEN vy2 = wy - 4
xleft = -3: 'IF vx2 + xleft < 0 THEN xleft = vx2 - 0
xright = 3: 'IF vx2 + xright > wx THEN xright = vx2 - wx
yleft = -3: 'IF vy2 + yleft < 0 THEN yleft = vy2 - 0
yright = 3: 'IF vy2 + yright > yx THEN yright = vy2 - wy
FOR y = -3 TO 3
 FOR x = -3 TO 3
  array_gr ( x, y ) = 0
 NEXT x
NEXT y
LINE ( 0, 0 )-( 5 * sz - 1, 5 * sz - 1 ), 0, BF
FOR y = yleft TO yright
 FOR x = xleft TO xright
  rr$ = SPACE$( 1 )
  GET # CSV_Stream ( CSV_MG ) .Filemode, ( vx2 + x + ( vy2 + y ) * wx + 4 ), rr$
  z = ASC ( rr$)
  array_gr ( x, y ) = z
  t = x + 3
  tt = y + 3
  'graphicput vm$( z ), ( t + 0 - 1 ) * sz+8, ( tt + 0 - 1 ) * sz+8
 NEXT x
NEXT y

vx1 = vx2
vy1 = vy2
'PCOPY 1, 0
'PCOPY 1, 2
'PCOPY 1, 3
''''LINE ( 0, 0 )-( 319, 199 ), 11, B
GOSUB 23000
'WHILE INKEY$ = "": WEND

500 :
beast = TIMER

'[!]update 1999 14/01
scrnupdt = 3

GOTO 20500

900 :
'VisCRSR ANIMATE
pc = POINT ( x, y ): pp = POINT ( xx, yy )
cc = 15 - POINT ( x, y )
IF px > 631 THEN px = 631
IF py > 341 THEN py = 341
IF TIMER - bt > BR THEN CB = ( CB MOD 4 ) + 1: bt = TIMER
IF ( CB = 1 OR CB = 3 ) THEN graphicput ( nm$ + "_" + c1$ + ".08x"), px, py, ""
IF CB = 2 THEN graphicput ( nm$ + "_" + c2$ + ".08x"), px, py, ""
IF CB = 4 THEN graphicput ( nm$ + "_" + c3$ + ".08x"), px, py, ""
RETURN

1000 :
'''''Area mem Save
Close # CSV_Stream ( CSV_SAV ) .Filemode : CSV_Stream ( CSV_SAV ) .Filemode = FreeFile ( )
OPEN nm$ + "_001.sav" FOR OUTPUT AS # CSV_Stream ( CSV_SAV ) .Filemode
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, p1$
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, vx2: '+vx2-1
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, vy2: '+vy2-1
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, d1
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, vx2
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, vy2
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, nm$
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, c1$
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, c2$
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, c3$
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, s
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, o
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, i
PRINT # CSV_Stream ( CSV_SAV ) .Filemode, p
Close # CSV_Stream ( CSV_SAV ) .Filemode
RETURN

20500 ''main
20502 RANDOMIZE TIMER
20505 c$ = INKEY$: cc$ = " " + c$ + " ": vx1 = vx2: vy1 = vy2: d1 = d2: g1 = g2
20506 'IF TIMER - beast > 30 AND INT ( RND ( 1 ) * 50 ) = 1 THEN pcopy 2,3:chain bt$,15,all
20507 'IF c$ = "W" OR c$ = "w" THEN pcopy 2,3:chain bt$,15,all
IF c$ = "i" OR c$ = "I" THEN i = 1 - i
REM'''IF c$ = "R" OR c$ = "r" THEN GOSUB 1000
'''IF c$ = "s" OR c$ = "S" THEN s = 1 - s
IF c$ = "o" OR c$ = "O" THEN o = ( o MOD 4 ) + 1
IF vx2 > wx THEN
 vx2 = wx
ELSE
 IF vx2 < 1 THEN
  vx2 = 1
 END IF
END IF
IF vy2 > wy THEN
 vy2 = wy
ELSE
 IF vy2 < 1 THEN
  vy2 = 1
 END IF
END IF
IF vx2 + Array_Rose ( d ) .X >= 0 AND vx2 + Array_Rose ( d ) .X <= wx AND vy2 + Array_Rose ( d ) .Y >= 0 AND vy2 + Array_Rose ( d ) .Y <= wy THEN

'[!]update 1999 14/01
IF scrnupdt = 3 THEN
 scrnupdt = 1
ELSE
 scrnupdt = 0
END IF

''[!]update 1999 14/01 - this portion is no longer needed
'x = 0
'y = 0
'GOSUB spotput

IF 1 = 1 THEN
REM'the following 4 blocked IFs allow terrein map alteration
 IF c$ = "+" AND array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) < 64 THEN
  rr$ = CHR$( array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) + 1 )
  PUT #1, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "-" AND array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) > 1 THEN
  rr$ = CHR$( array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) - 1 )
  PUT #1, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "f" AND array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) < 64 - 16 THEN
  rr$ = CHR$( array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) + 16 )
  PUT #1, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "F" AND array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) > 1 + 16 THEN
  rr$ = CHR$( array_gr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) - 16 )
  PUT #1, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
END IF

IF 1 = 1 THEN
REM'the following 3 blocked IFs allow object map alteration
 IF c$ = CHR$( 8 ) AND array_cr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) > 0 THEN
  rr$ = CHR$( 0 )
  PUT #2, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "*" AND array_cr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) < 255 THEN
  rr$ = CHR$( array_cr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) + 1 )
  PUT #2, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "/" AND array_cr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) > 0 THEN
  rr$ = CHR$( array_cr ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) - 1 )
  PUT #2, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
END IF

IF 1 = 1 THEN
REM'the following 3 blocked IFs allow low object map alteration
 IF c$ = "\" AND array_cs ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) > 0 THEN
  rr$ = CHR$( 0 )
  PUT #3, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "]" AND array_cs ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) < 255 THEN
  rr$ = CHR$( array_cs ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) + 1 )
  PUT #3, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
 IF c$ = "[" AND array_cs ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) > 0 THEN
  rr$ = CHR$( array_cs ( vx2 - vx1 + Array_Rose ( d2 ) .X, vx2 - vx1 + Array_Rose ( d2 ) .Y ) - 1 )
  PUT #3, ( vx2 + Array_Rose ( d2 ) .X + ( vy2 + Array_Rose ( d2 ) .Y ) * wx + 4 ), rr$
  scrnupdt = 1
 END IF
END IF

 IF c$ = "y" OR c$ = CHR$( 0 ) + CHR$( 72 ) THEN
  d2 = 1
  IF array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ) = 0 AND array_obj_m ( array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )) <> 0 THEN
  vx2 = vx2 + Array_Rose ( d2 ) .X
  vy2 = vy2 + Array_Rose ( d2 ) .Y
  scrnupdt = 1
  END IF
 END IF
 IF c$ = "h" OR c$ = CHR$( 0 ) + CHR$( 77 ) THEN
  d2 = 2
  IF array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ) = 0 AND array_obj_m ( array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )) <> 0 THEN
  vx2 = vx2 + Array_Rose ( d2 ) .X
  vy2 = vy2 + Array_Rose ( d2 ) .Y
  scrnupdt = 1
  END IF
 END IF
 IF c$ = "b" OR c$ = CHR$( 0 ) + CHR$( 80 ) THEN
  d2 = 3
  IF array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ) = 0 AND array_obj_m ( array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )) <> 0 THEN
  vx2 = vx2 + Array_Rose ( d2 ) .X
  vy2 = vy2 + Array_Rose ( d2 ) .Y
  scrnupdt = 1
  END IF
 END IF
 IF c$ = "g" OR c$ = CHR$( 0 ) + CHR$( 75 ) THEN
  d2 = 4
  IF array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ) = 0 AND array_obj_m ( array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )) <> 0 THEN
  vx2 = vx2 + Array_Rose ( d2 ) .X
  vy2 = vy2 + Array_Rose ( d2 ) .Y
  scrnupdt = 1
  END IF
 END IF
END IF
IF INSTR (" Y y 8 ", cc$) > 0 OR c$ = CHR$( 0 ) + CHR$( 72 ) THEN d2 = 1
IF INSTR (" H h 6 ", cc$) > 0 OR c$ = CHR$( 0 ) + CHR$( 77 ) THEN d2 = 2
IF INSTR (" B b 2 ", cc$) > 0 OR c$ = CHR$( 0 ) + CHR$( 80 ) THEN d2 = 3
IF INSTR (" G g 4 ", cc$) > 0 OR c$ = CHR$( 0 ) + CHR$( 75 ) THEN d2 = 4
IF INSTR (" 5 ", cc$) > 0 THEN
 d2 = 0
 'vx2 = vx1 + Array_Rose ( d2 ) .X
 'vy2 = vy1 + Array_Rose ( d2 ) .Y
END IF
IF INSTR (" 7 ", cc$) > 0 THEN d2 = (( d2 + 2 ) MOD 4 ) + 1
IF INSTR (" 9 ", cc$) > 0 THEN d2 = ( d2 MOD 4 ) + 1
IF c$ = "." THEN p = 1 - p
g2 = array_gr ( vx2 - vx1, vy2 - vy1 )
IF p <> 1 OR INSTR ( 1, rd$, g2$) = 0 OR GE < 4 THEN 20550

g2 = 0
f2 = 0
g2$ = "_"
WHILE INSTR ( 1, rd$, g2$) = 0 AND f2 < 5
 f2 = f2 + 1
 d2 = (( d1 + array_m ( f2 ) - 1 ) MOD 4 ) + 1
 vx2 = vx1 + Array_Rose ( d2 ) .X
 vy2 = vy1 + Array_Rose ( d2 ) .Y
 scrnupdt = 1
 IF vx2 > wx THEN
  vx2 = wx
 ELSE
  IF vx2 < 1 THEN
   vx2 = 1
  END IF
 END IF
 IF vy2 > wy THEN
  vy2 = wy
 ELSE
  IF vy2 < 1 THEN
   vy2 = 1
  END IF
 END IF
 g2 = array_gr ( vx2 - vx1, vy2 - vy1 )
 g2$ = STR$( g2 ) + " "
WEND

20550 :
IF vx2 <> vx1 OR vy2 <> vy1 THEN GE = 1
IF f2 = 5 THEN
 vx2 = vx1
 vy2 = vy1
 d2 = d1
END IF
IF vx2 > wx THEN
 vx2 = wx
ELSE
 IF vx2 < 1 THEN
  xv2 = 1
 END IF
END IF
IF vy2 > wy THEN
 vy2 = wy
ELSE
 IF vy2 < 1 THEN
  vy2 = 1
 END IF
END IF
g2 = array_gr ( vx2 - vx1, vy2 - vy1 )
g2$ = STR$( g2 ) + " "
REM'the following two lines limit movement
IF INSTR ( 1, array_ck$( d2 ), g2$) > 0 THEN vx2 = vx1: vy2 = vy1: g2 = g1
IF array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ) <> 0 THEN vx2 = vx1: vy2 = vy1: g2 = g1

IF vx2 > wx THEN vx2 = wx ELSE IF vx2 < 1 THEN vx2 = 1
IF vy2 > wy THEN vy2 = wy ELSE IF vy2 < 1 THEN vy2 = 1

'''( vx1/vx2,vy1/vy2 final )

FOR y = -3 TO 3
 FOR x = -3 TO 3
 array_lc ( x, y ) = 0
 NEXT x
NEXT y

IF gc = 4 THEN
 FOR y = -3 TO 3
 FOR x = -3 TO 3
  IF array_cr ( x, y ) > 1 AND array_lc ( x, y ) = 0 THEN
  array_lc ( x, y ) = 1
  actionr$ = ""
  dirr = INT ( RND ( 1 ) * 4 ) + 1
  IF x + Array_Rose ( dirr ) .X > -4 AND x + Array_Rose ( dirr ) .X < 4 AND y + Array_Rose ( dirr ) .Y > -4 AND y + Array_Rose ( dirr ) .Y < 4 THEN
   IF array_cr ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y ) = 0 THEN
   IF INT ( RND ( 1 ) * objs ( array_cr ( x, y ))) > 0 AND objs ( array_cr ( x, y )) <> 0 THEN
    actionr$ = "move"
   ELSE
    actionr$ = ""
   END IF
   ELSE
   IF INT ( RND ( 1 ) * objs ( array_cr ( x, y ))) > 0 AND objs ( array_cr ( x, y )) <> 0 THEN
    actionr$ = "attack"
   ELSE
    actionr$ = ""
   END IF
   END IF
  
   IF actionr$ = "move" THEN
   REM'the following two lines limit movement
   IF INSTR ( 1, array_ck$( dirr ), ( STR$( array_gr ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y )) + " ")) > 0 THEN actionr$ = ""
   IF array_cr ( Array_Rose ( dirr ) .X, Array_Rose ( dirr ) .Y ) <> 0 THEN actionr$ = ""
   IF array_obj_m ( array_cs ( Array_Rose ( dirr ) .X, Array_Rose ( dirr ) .Y )) = 0 THEN actionr$ = ""
   END IF

   '[!]update 1999 14/01
   IF actionr$ = "move" AND array_cs ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y ) = 0 THEN
   SWAP array_lc ( x, y ), array_lc ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y )
   
   SWAP array_cr ( x, y ), array_cr ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y )
   rr$ = CHR$( array_cr ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y ))
   PUT #2, ( vx1 + x + Array_Rose ( dirr ) .X + ( vy1 + y + Array_Rose ( dirr ) .Y ) * wx + 4 ), rr$
   rr$ = CHR$( array_cr ( x, y ))
   PUT #2, ( vx1 + x + ( vy1 + y ) * wx + 4 ), rr$
   
'[!]bugfix 1999 17/01  
   'SWAP array_cs ( x, y ), array_cs ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y )
   'rr$ = CHR$( array_cs ( x + Array_Rose ( dirr ) .X, y + Array_Rose ( dirr ) .Y ))
   'PUT #3, ( vx1 + x + Array_Rose ( dirr ) .X + ( vy1 + y + Array_Rose ( dirr ) .Y ) * wx + 4 ), rr$
   'rr$ = CHR$( array_cs ( x, y ))
   'PUT #3, ( vx1 + x + ( vy1 + y ) * wx + 4 ), rr$
   
'[!]update 1999 14/01
   IF scrnupdt = 0 THEN GOSUB spotput
  
   END IF
  
   IF actionr$ = "attack" THEN
   END IF

  END IF
  END IF
 NEXT x
 NEXT y
END IF

'timers

IF TIMER - BR > bt THEN BR = TIMER: gc = ( gc MOD 4 ) + 1
IF TIMER - sb > sa THEN sb = TIMER: GE = ( GE MOD 4 ) + 1
IF gc = 4 THEN timm = timm + 1

IF ( vx1 <> vx2 OR vy1 <> vy2 ) THEN
 timm = timm + INT ( RND ( 1 ) * 15 ) + 15 + 1
END IF

IF timd = 0 THEN timd = 1
WHILE timm >= 60
 timm = timm - 60
 timh = timh + 1
WEND
WHILE timh >= 24
 timh = timh - 24
 timd = timd + 1
WEND

IF ( vx1 <> vx2 OR vy1 <> vy2 ) THEN
 SWAP array_cr ( 0, 0 ), array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )
 rr$ = CHR$( array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ))
 PUT #2, ( vx2 + vy2 * wx + 4 ), rr$
 rr$ = CHR$( array_cr ( 0, 0 ))
 PUT #2, ( vx1 + vy1 * wx + 4 ), rr$
END IF

'[!]bugfix 1999 17/01
'IF ( vx1 <> vx2 OR vy1 <> vy2 ) THEN
' SWAP array_cs ( 0, 0 ), array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )
' rr$ = CHR$( array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y ))
' PUT #3, ( vx2 + vy2 * wx + 4 ), rr$
' rr$ = CHR$( array_cs ( 0, 0 ))
' PUT #3, ( vx1 + vy1 * wx + 4 ), rr$
'END IF

'set old values at new
vx1 = vx2
vy1 = vy2
d1 = d2
g1 = g2
IF c$ = CHR$( 27 ) THEN SCREEN 0, 0, 0, 0: WIDTH 80: COLOR 15, 1: VIEW PRINT 1 TO 25: CLS : GOSUB 1000: END
'PCOPY 2, 1


'[!]update 1999 14/01
'''the following blocked if calls the graphics viewscreen
IF scrnupdt = 1 THEN
 GOSUB 22000
ELSE
 IF 1 = 1 THEN
 '[!]update 1999 14/01
 FOR y = -3 TO 3
  FOR x = -3 TO 3
  GOSUB spotupdt
  NEXT x
 NEXT y
 END IF
END IF

20615 IF c$ = "p" OR c$ = "P" THEN WHILE INKEY$ = "": WEND
20616 'IF o = 2 THEN 20650
20617 'IF o = 1 OR o = 3 THEN oo = 1 - oo: IF oo = 1 THEN 20650
20621 'LINE ( 0 - 8, 0 - 8 )-( 327, ( vy2 - 4 ) * 8 - 4 ), 3, BF: '1
20622 'LINE ( 327, 0 - 8 )-(( vx2 + 4 ) * 8 + 4, 207 ), 3, BF: '2
20623 'LINE ( 0 - 8, 207 )-( 327, ( vy2 + 3 ) * 8 + 4 ), 3, BF: '3
20624 'LINE ( 0 - 8, 0 - 8 )-(( vx2 - 5 ) * 8 - 4, 207 ), 3, BF: '4
20625 'LINE (( vx2 - 5 ) * 8 - 4, ( vy2 - 4 ) * 8 - 4 )-(( vx2 + 4 ) * 8 + 4, ( vy2 + 3 ) * 8 + 4 ), 11, B

20650 IF i = 0 THEN 20730
20651 ''''LINE (( 73 - 1 ) * 8, ( 1 - 1 ) * 8 )-(( 80 * 8 ) - 1, ( 25 * 8 ) - 1 ), 0, BF
20652 COLOR 5: LOCATE 2, 33: IF gc = 1 OR gc = 3 THEN COLOR 13: PRINT "PuZzLuM";
20653 IF gc = 2 OR gc = 4 THEN COLOR 5: PRINT "pUzZlUm"; : COLOR 15
20654 COLOR 11: LOCATE 3, 33: PRINT P2$; : COLOR 15
20655 COLOR 15: LOCATE 5, 33: PRINT nm$;
20656 COLOR 15: LOCATE 6, 33: PRINT "Aim:"; : COLOR 9: IF p = 1 THEN COLOR 1
20658 PRINT array_a$( d2 ); : COLOR 15
20659 COLOR 15: LOCATE 7, 33: PRINT "Arm:"; : COLOR 8: IF GE >= 4 THEN COLOR 15
20660 PRINT GE; : COLOR 15

LOCATE 9, 33
timd$ = RIGHT$( STR$( 1000 + ( timd MOD 365 ) + 1 ), 3 )
PRINT "Day " + timd$;
LOCATE 10, 33
timh$ = RIGHT$( STR$( 1000 + ( timh MOD 12 ) + 1 ), 2 )
timm$ = RIGHT$( STR$( 1000 + ( timm MOD 60 )), 2 )
PRINT timh$ + ":" + timm$;
IF timh < 12 THEN PRINT "am"
IF timh >= 12 THEN PRINT "pm"

'Array_Pal ( 1 ) .R = INT ( 7 + 15 * ABS ( COS ( TIMER / 10 + .2 )))
'Array_Pal ( 1 ) .B = INT ( 15 + 31 * ABS ( COS ( TIMER / 10 )))
'Array_Pal ( 9 ) .R = INT ( 7 + 7 * ABS ( COS ( TIMER / 10 + .2 )))
'Array_Pal ( 9 ) .B = INT ( 31 + 15 * ABS ( COS ( TIMER / 10 + .3 )))
'dark = ( 12 * 60 - ABS ( timh * 60 + timm - 12 * 60 )) / ( 12 * 60 )
'IF dark < 0 THEN dark = 0
'IF dark > 1 THEN dark = 1
'pal = ( pal + 1 ) MOD 16
'PALETTE pal, INT ( array_pal ( pal, 1 ) * dark ) + INT ( array_pal ( pal, 2 ) * dark ) * 256 + INT ( array_pal ( pal, 3 ) * dark ) * 256 ^ 2

''day palette
'IF ( timh >= 5 AND timh < 21 ) AND pal = 0 THEN
' pal = 1
' PALETTE
'END IF
''night palette
'IF ( timh < 5 OR timh >= 21 ) AND pal = 1 THEN
' pal = 0
' IF 1 = 0 THEN
' FOR ttt = 0 TO 15
'  PALETTE 0, INT ( array_pal ( ttt, 1 ) * dark ) + INT ( array_pal ( ttt, 2 ) * dark ) * 256 + INT ( array_pal ( ttt, 3 ) * dark ) * 256 ^ 2
' NEXT ttt
' END IF
'END IF

'[!]update 1999 13/01
'palette rotation for 239 - 242
t# = ( TIMER * 4 ) MOD 4
FOR tt# = 0 TO 3
	t = ( 239 + ( tt# + t# + 0 ) MOD 4 )
	Array_Pal ( t ) .R = 63
	Array_Pal ( t ) .G = ( 16 * tt#)
	Array_Pal ( t ) .B = ( 8 * tt#)
	Palette t, __RGBA ( Array_Pal ( t ) .R, Array_Pal ( t ) .G, Array_Pal ( t ) .B, 255 ) 
NEXT tt#

LOCATE 12, 33
PRINT "gr:"; RIGHT$( STR$( 1000 + array_gr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )), 3 );
LOCATE 13, 33
PRINT "cr:"; RIGHT$( STR$( 1000 + array_cr ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )), 3 );
LOCATE 14, 33
PRINT "cs:"; RIGHT$( STR$( 1000 + array_cs ( Array_Rose ( d2 ) .X, Array_Rose ( d2 ) .Y )), 3 );

'[!]update 1999 12/01
'displays coordinates
LOCATE 16, 33
PRINT "x:"; vx2;
LOCATE 17, 33
PRINT "y:"; vy2;

'[!]update 1999 12/01
'displays key code
'LOCATE 19, 33
'PRINT "#:"; ASC ( RIGHT$( CHR$( 0 ) + c$, 1 ));

20720 'LINE (( 1-1 )*8,( 1-1 )*8 )-(( wx*8 )-1,( wy*8 )-1 ),11,B,22035
20730 'PCOPY 1, 0
20735 '''IF EOF ( 2 ) THEN CLOSE 2: OPEN bm$ FOR INPUT AS 2
20736 '''IF s = 1 THEN INPUT #2, n, l: SOUND n + 100, .8

'PCOPY 1, 0
GOSUB 22500

20740 GOTO 20500

22000 :
'''''Map Load & View Screen
'PCOPY 2, 1
IF vx2 - 3 < 1 THEN vx2 = 4
IF vy2 - 3 < 1 THEN vy2 = 4
IF vx2 + 3 > wx THEN vx2 = wx - 4
IF vy2 + 3 > wy THEN vy2 = wy - 4
xleft = -3: 'IF vx2 + xleft < 0 THEN xleft = vx2 - 0
xright = 3: 'IF vx2 + xright > wx THEN xright = vx2 - wx
yleft = -3: 'IF vy2 + yleft < 0 THEN yleft = vy2 - 0
yright = 3: 'IF vy2 + yright > yx THEN yright = vy2 - wy
FOR y = -3 TO 3
 FOR x = -3 TO 3
  array_gr ( x, y ) = 0
  array_cr ( x, y ) = 0
 NEXT x
NEXT y
''''LINE ( 0 + 8, 0 + 8 )-( 5 * sz - 1 + 8, 5 * sz - 1 + 8 ), 0, BF
FOR y = yleft TO yright
 FOR x = xleft TO xright
  
  GOSUB spotput

  'PSET (( 320 - wx / 2 ) + vx2 + x, ( 175 - wy / 2 ) + vy2 + y ), varray_m ( z )
 NEXT x
NEXT y
'PCOPY 1, 2
'PSET (( 320 - wx / 2 ) - 1, ( 175 - wy / 2 ) - 1 ), 11
'LINE -(( 320 - wx / 2 ) + wx + 1, ( 175 - wy / 2 ) + wy + 1 ), 11, B
'PSET (( 320 - wx / 2 ) + vx2 + xleft, ( 175 - wy / 2 ) + vy2 + yleft ), 8
'LINE -(( 320 - wx / 2 ) + vx2 + xright, ( 175 - wy / 2 ) + vy2 + yright ), 8, B
RETURN

22500 :
FOR y = yleft TO yright
 FOR x = xleft TO xright
  rr$ = SPACE$( 1 )
  GET #1, ( vx2 + x + ( vy2 + y ) * wx + 4 ), rr$
  z = ASC ( rr$)
  array_gr ( x, y ) = z
  't = x + 3
  'tt = y + 3
  'graphicput vm$( z ), ( t + 0 - 1 ) * sz + 8, ( tt + 0 - 1 ) * sz + 8
  'PSET (( 320 - wx / 2 ) + vx2 + x, ( 175 - wy / 2 ) + vy2 + y ), varray_m ( z )
 NEXT x
NEXT y
'PSET (( 320 - wx / 2 ) - 1, ( 175 - wy / 2 ) - 1 ), 11
'LINE -(( 320 - wx / 2 ) + wx + 1, ( 175 - wy / 2 ) + wy + 1 ), 11, B
RETURN

23000 :
'''''Map View
'PCOPY 2, 1
'PSET (( 320 - wx / 2 ) - 1, ( 175 - wy / 2 ) - 1 ), 11
'LINE -(( 320 - wx / 2 ) + wx + 1, ( 175 - wy / 2 ) + wy + 1 ), 11, B

IF 1 = 0 THEN

FOR y = 0 TO wy
 FOR x = 0 TO wx
  
  REM' the following blocked if blanks the object map
  IF 1 = 1 THEN
   rr$ = CHR$( 0 )
   PUT #2, ( x + y * wx + 4 ), rr$
  END IF
  
  REM' the following blocked if blanks the low object map
  IF 1 = 1 THEN
   rr$ = CHR$( 0 )
   PUT #3, ( x + y * wx + 4 ), rr$
  END IF

  rr$ = SPACE$( 1 )
  GET #1, ( x + y * wx + 4 ), rr$
  z = ASC ( rr$)
  PSET (( 320 - wx / 2 ) + x, ( 175 - wy / 2 ) + y ), varray_m ( z )
 NEXT x
 'PCOPY 1, 0
NEXT y
'PCOPY 1, 2
'WHILE INKEY$ = "": WEND
'PSET (( 320 - wx / 2 ) - 1, ( 175 - wy / 2 ) - 1 ), 11
'LINE -(( 320 - wx / 2 ) + wx + 1, ( 175 - wy / 2 ) + wy + 1 ), 11, B

END IF

CLS
'PCOPY 1, 0

IF 1 = 0 THEN
 FOR y = 0 TO wy
 FOR x = 0 TO wx
  rr$ = CHR$( 0 )
  PUT #2, ( x + y * wx + 4 ), rr$
  rr$ = CHR$( 0 )
  PUT #3, ( x + y * wx + 4 ), rr$
 NEXT x
 NEXT y
END IF

'rr$ = CHR$( 1 )
'PUT #2, ( vx1 + vy1 * wx + 4 ), rr$

RETURN

23100 'VisCMND
23102 'PCOPY 1, 0
23105 ZL = 0: z = 0: z$ = "": CB = 1: IN$ = "": il = LEN ( IN$)
23110 z$ = INKEY$: IF z$ <> "" THEN 23150

23115 :
COLOR 15: LOCATE , 1: PRINT IN$; : il = LEN ( IN$)

23116 'IF CB=1 THEN COLOR 9
23117 'IF CB=2 THEN COLOR 12
23118 'IF CB=3 THEN COLOR 14
23120 'LOCATE ,IL+1:PRINT MID$("۲",CB,1 );" ";:COLOR 15
23121 'LOCATE ,IL+1:PRINT MID$("",CB,1 );" ";:COLOR 15
23122 __GetMouse ( px, py, , PB ): PB = PB And 1
23123 'IF PB=-1 THEN X=INT ( PX/8 ):Y=INT (( PY/8 )
23124 'IF pb<>-1 THEN px=( pos ( 0 )-1 )*8:py=( csrlin-1 )*8 )
23125 x = ( POS ( 0 ) - 1 ) * 8: py = ( CSRLIN - 1 ) * 8
23126 IF px > 311 THEN px = 311 ELSE IF px < 0 THEN px = 0
23127 IF py > 191 THEN py = 191 ELSE IF py < 0 THEN py = 0
23128 LOCATE , il + 1: PRINT " "; : COLOR 15
23129 COLOR 5: LOCATE , il + 1: PRINT MID$("", CB, 1 ); " "; : COLOR 15
23130 'PCOPY 1, 0
23131 IF TIMER - bt > BR THEN CB = ( CB MOD 3 ) + 1: bt = TIMER
23140 GOTO 23110
23150 ZL = LEN ( z$): z = ASC ( z$)
23160 IF ( z < 32 OR z > 125 ) AND z <> 13 AND z <> 8 AND z <> 27 THEN 23115
23170 IF ( z >= 32 AND z <= 125 ) AND il < 70 AND il < 36 THEN IN$ = IN$ + z$: il = LEN ( IN$): GOTO 23115
23180 IF z = 8 AND il > 0 THEN IN$ = LEFT$( IN$, il - 1 ): il = LEN ( IN$): GOTO 23115
23190 IF z = 13 THEN COLOR 15: LOCATE , 1: PRINT IN$; "  "; : PRINT : RETURN
23200 IF z = 27 THEN IN$ = "": COLOR 15: LOCATE , 1: PRINT STRING$( 35, CHR$( 32 )): PRINT : RETURN
23210 il = LEN ( IN$): PCOPY 1, 0: GOTO 23115

'[!]update 1999 14/01
'[!]bugfix 1999 17/01
spotput:
  t = x + 4
  tt = y + 4

  rr$ = SPACE$( 1 )
  GET #1, ( vx2 + x + ( vy2 + y ) * wx + 4 ), rr$
  z = ASC ( rr$)
  array_gr ( x, y ) = z
  
  chrb$ = SPACE$( 1 )
  GET #3, ( vx2 + x + ( vy2 + y ) * wx + 4 ), chrb$
  chrb = ASC ( chrb$)
  array_cs ( x, y ) = chrb
  
  chrc$ = SPACE$( 1 )
  GET #2, ( vx2 + x + ( vy2 + y ) * wx + 4 ), chrc$
  chrc = ASC ( chrc$)
  array_cr ( x, y ) = chrc

  graphicput vm$( z ), ( t - 1 ) * sz, ( tt - 1 ) * sz, "pset"

  IF chrb > 0 AND array_obj_m ( chrb ) < 2 THEN
   graphicput LEFT$( array_obj$( chrb, gc ), 4 ) + "-" + RIGHT$( array_obj$( chrb, gc ), 7 ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "and"
   graphicput array_obj$( chrb, gc ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "or"
  END IF
  
  IF chrc > 0 THEN
   graphicput LEFT$( array_obj$( chrc, gc ), 4 ) + "-" + RIGHT$( array_obj$( chrc, gc ), 7 ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), "and"
   graphicput array_obj$( chrc, gc ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), "or"
  END IF
  
  IF chrb > 0 AND array_obj_m ( chrb ) = 2 THEN
   graphicput LEFT$( array_obj$( chrb, gc ), 4 ) + "-" + RIGHT$( array_obj$( chrb, gc ), 7 ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "and"
   graphicput array_obj$( chrb, gc ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "or"
  END IF

RETURN

'[!]update 1999 14/01
'[!]bugfix 1999 17/01
spotupdt:
  t = x + 4
  tt = y + 4
 
  rr$ = SPACE$( 1 )
  GET # CSV_Stream ( CSV_MG ) .Filemode, ( vx2 + x + ( vy2 + y ) * wx + 4 ), rr$
  z = ASC ( rr$)
  chrb$ = SPACE$( 1 )
  GET # CSV_Stream ( CSV_MGC ) .Filemode, ( vx2 + x + ( vy2 + y ) * wx + 4 ), chrb$
  chrb = ASC ( chrb$)
  chrc$ = SPACE$( 1 )
  GET # CSV_Stream ( CSV_MGB ) .Filemode, ( vx2 + x + ( vy2 + y ) * wx + 4 ), chrc$
  chrc = ASC ( chrc$)
 
  IF chrc > 0 AND array_obj_m ( chrb ) < 2 THEN

   graphicput vm$( z ), ( t - 1 ) * sz, ( tt - 1 ) * sz, "pset"

   IF chrb > 0 AND array_obj_m ( chrb ) < 2 THEN
   graphicput LEFT$( array_obj$( chrb, gc ), 4 ) + "-" + RIGHT$( array_obj$( chrb, gc ), 7 ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "and"
   graphicput array_obj$( chrb, gc ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "or"
   END IF
 
   IF chrc > 0 THEN
   graphicput LEFT$( array_obj$( chrc, gc ), 4 ) + "-" + RIGHT$( array_obj$( chrc, gc ), 7 ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), "and"
   graphicput array_obj$( chrc, gc ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrc )) / 2 ), "or"
   END IF
 
   IF chrb > 0 AND array_obj_m ( chrb ) = 2 THEN
   graphicput LEFT$( array_obj$( chrb, gc ), 4 ) + "-" + RIGHT$( array_obj$( chrb, gc ), 7 ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "and"
   graphicput array_obj$( chrb, gc ), ( t - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), ( tt - 1 ) * sz + INT (( sz - array_obj ( chrb )) / 2 ), "or"
   END IF
  
  END IF
RETURN

SUB graphicput ( grpt$, x, y, m$)
MID$( grpt$, 12, 1 ) = "v"
IF x + sz - 1 < 640 AND y + sz - 1 < 350 THEN
 'IF grpt$ = "" THEN LINE ( x, y )-( x + sz - 1, y + sz - 1 ), 0, BF
 IF grpt$ <> "" THEN
 'DEF SEG = VARSEG ( array_scn ( 0 ))
 'BLOAD grpt$, VARPTR ( array_scn ( 0 ))
 BLOAD grpt$, VARPTR ( array_scn ( 0 ))
 IF m$ = "or" THEN
  PUT ( x, y ), array_scn ( 0 ), OR
 END IF
 IF m$ = "and" THEN
  PUT ( x, y ), array_scn ( 0 ), AND
 END IF
 IF m$ = "pset" THEN
  PUT ( x, y ), array_scn ( 0 ), PSET
 END IF
 END IF
END IF
'GET ( 0, 0 )-( 7, 7 ), scn
'DEF SEG = VARSEG ( array_scn ( 0 ))
'BSAVE grpt$, VARPTR ( array_scn ( 0 )), 8 * 8 + 8
END SUB
